## ros-foxy-demo-nodes-cpp 0.9.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(demo_nodes_cpp)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake REQUIRED)
find_package(example_interfaces REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_components REQUIRED)
find_package(rcutils)
find_package(rmw REQUIRED)
find_package(std_msgs REQUIRED)

include_directories(include)

function(custom_executable subfolder target)
  add_executable(${target} src/${subfolder}/${target}.cpp)
  ament_target_dependencies(${target}
    "example_interfaces"
    "rclcpp"
    "rcutils"
    "std_msgs")
  install(TARGETS ${target}
  DESTINATION lib/${PROJECT_NAME})
endfunction()

function(add_demo_dependencies library)
  target_compile_definitions(${library}
    PRIVATE "DEMO_NODES_CPP_BUILDING_DLL")
  ament_target_dependencies(${library}
    "example_interfaces"
    "rclcpp"
    "rclcpp_components"
    "rcutils"
    "std_msgs")
endfunction()
# Tutorials of Publish/Subscribe with Topics
custom_executable(topics allocator_tutorial)

# Tutorials of Request/Response with Services
custom_executable(services add_two_ints_client)

# Tutorials of Parameters with Asynchronous and Synchronous
custom_executable(parameters list_parameters_async)
custom_executable(parameters parameter_events)
custom_executable(parameters set_and_get_parameters_async)

add_library(timers_library SHARED
  src/timers/one_off_timer.cpp
  src/timers/reuse_timer.cpp)
add_library(services_library SHARED
  src/services/add_two_ints_server.cpp
  src/services/add_two_ints_client.cpp
  src/services/add_two_ints_client_async.cpp)
add_library(parameters_library SHARED
  src/parameters/list_parameters.cpp
  src/parameters/parameter_blackboard.cpp
  src/parameters/set_and_get_parameters.cpp
  src/parameters/parameter_events_async.cpp
  src/parameters/even_parameters_node.cpp)
add_library(topics_library SHARED
  src/topics/talker.cpp
  src/topics/talker_loaned_message.cpp
  src/topics/talker_serialized_message.cpp
  src/topics/listener.cpp
  src/topics/listener_serialized_message.cpp
  src/topics/listener_best_effort.cpp)
add_demo_dependencies(timers_library)
add_demo_dependencies(services_library)
add_demo_dependencies(parameters_library)
add_demo_dependencies(topics_library)

rclcpp_components_register_node(timers_library
  PLUGIN "demo_nodes_cpp::OneOffTimerNode"
  EXECUTABLE one_off_timer)
rclcpp_components_register_node(timers_library
  PLUGIN "demo_nodes_cpp::ReuseTimerNode"
  EXECUTABLE reuse_timer)

rclcpp_components_register_node(services_library
  PLUGIN "demo_nodes_cpp::ServerNode"
  EXECUTABLE add_two_ints_server)
rclcpp_components_register_node(services_library
  PLUGIN "demo_nodes_cpp::ClientNode"
  EXECUTABLE add_two_ints_client_async)

rclcpp_components_register_node(parameters_library
  PLUGIN "demo_nodes_cpp::ListParameters"
  EXECUTABLE list_parameters)
rclcpp_components_register_node(parameters_library
  PLUGIN "demo_nodes_cpp::ParameterBlackboard"
  EXECUTABLE parameter_blackboard)
rclcpp_components_register_node(parameters_library
  PLUGIN "demo_nodes_cpp::SetAndGetParameters"
  EXECUTABLE set_and_get_parameters)
rclcpp_components_register_node(parameters_library
  PLUGIN "demo_nodes_cpp::ParameterEventsAsyncNode"
  EXECUTABLE parameter_events_async)
rclcpp_components_register_node(parameters_library
  PLUGIN "demo_nodes_cpp::EvenParameterNode"
  EXECUTABLE even_parameters_node)

rclcpp_components_register_node(topics_library
  PLUGIN "demo_nodes_cpp::Talker"
  EXECUTABLE talker)
rclcpp_components_register_node(topics_library
  PLUGIN "demo_nodes_cpp::LoanedMessageTalker"
  EXECUTABLE talker_loaned_message)
rclcpp_components_register_node(topics_library
  PLUGIN "demo_nodes_cpp::SerializedMessageTalker"
  EXECUTABLE talker_serialized_message)
rclcpp_components_register_node(topics_library
  PLUGIN "demo_nodes_cpp::Listener"
  EXECUTABLE listener)
rclcpp_components_register_node(topics_library
  PLUGIN "demo_nodes_cpp::SerializedMessageListener"
  EXECUTABLE listener_serialized_message)
rclcpp_components_register_node(topics_library
  PLUGIN "demo_nodes_cpp::ListenerBestEffort"
  EXECUTABLE listener_best_effort)

install(TARGETS
  timers_library
  services_library
  parameters_library
  topics_library
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin)

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()

  find_package(ament_cmake_pytest REQUIRED)
  find_package(launch_testing_ament_cmake REQUIRED)
  find_package(rmw_implementation_cmake REQUIRED)
  # Add each test case.  Multi-executable tests can be specified in
  # semicolon-separated strings, like  exe1;exe2.
  set(tutorial_tests
    list_parameters_async
    list_parameters
    parameter_events_async
    parameter_events
    set_and_get_parameters_async
    set_and_get_parameters
    "talker:listener")
  set(service_tutorial_tests
    "add_two_ints_server:add_two_ints_client"
    "add_two_ints_server:add_two_ints_client_async"
  )

  macro(tests)
    set(tutorial_tests_to_test ${tutorial_tests})
    list(APPEND tutorial_tests_to_test ${service_tutorial_tests})

    foreach(tutorial_test ${tutorial_tests_to_test})
      string(REPLACE ":" ";" tutorial_executables "${tutorial_test}")
      set(DEMO_NODES_CPP_EXPECTED_OUTPUT "")
      foreach(executable ${tutorial_executables})
        list(APPEND DEMO_NODES_CPP_EXPECTED_OUTPUT "${CMAKE_CURRENT_SOURCE_DIR}/test/${executable}")
      endforeach()

      set(DEMO_NODES_CPP_EXECUTABLE "")
      foreach(executable ${tutorial_executables})
        list(APPEND DEMO_NODES_CPP_EXECUTABLE "$<TARGET_FILE:${executable}>")
      endforeach()

      string(REPLACE ";" "_" exe_list_underscore "${tutorial_executables}")
      configure_file(
        test/test_executables_tutorial.py.in
        test_${exe_list_underscore}${target_suffix}.py.configured
        @ONLY
      )
      file(GENERATE
        OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/test_${exe_list_underscore}${target_suffix}_$<CONFIG>.py"
        INPUT "${CMAKE_CURRENT_BINARY_DIR}/test_${exe_list_underscore}${target_suffix}.py.configured"
      )

      add_launch_test(
        "${CMAKE_CURRENT_BINARY_DIR}/test_${exe_list_underscore}${target_suffix}_$<CONFIG>.py"
        TARGET test_tutorial_${exe_list_underscore}${target_suffix}
        TIMEOUT 60
        ENV
        RCL_ASSERT_RMW_ID_MATCHES=${rmw_implementation}
        RMW_IMPLEMENTATION=${rmw_implementation}
      )
      foreach(executable ${tutorial_executables})
        set_property(
          TEST test_tutorial_${exe_list_underscore}${target_suffix}
          APPEND PROPERTY DEPENDS ${executable}${target_suffix})
      endforeach()
    endforeach()
  endmacro()

  call_for_each_rmw_implementation(tests)
endif()

# Install launch files.
install(DIRECTORY
  launch
  DESTINATION share/${PROJECT_NAME}/
)

ament_package()

=== debian/changelog ===
ros-foxy-demo-nodes-cpp (0.9.4-1focal) focal; urgency=high

  * Update maintainer list for Foxy (#471 <https://github.com/ros2/demos/issues/471>)
  * Contributors: Michael Jeronimo

 -- Mabel Zhang <mabel@openrobotics.org>  Mon, 25 Jul 2022 07:00:00 -0000

ros-foxy-demo-nodes-cpp (0.9.3-1focal) focal; urgency=high



 -- William Woodall <william@osrfoundation.org>  Mon, 01 Jun 2020 07:00:00 -0000

ros-foxy-demo-nodes-cpp (0.9.2-1focal) focal; urgency=high



 -- William Woodall <william@osrfoundation.org>  Tue, 26 May 2020 07:00:00 -0000

ros-foxy-demo-nodes-cpp (0.9.1-1focal) focal; urgency=high



 -- William Woodall <william@osrfoundation.org>  Tue, 12 May 2020 07:00:00 -0000

ros-foxy-demo-nodes-cpp (0.9.0-1focal) focal; urgency=high

  * avoid new deprecations (#442 <https://github.com/ros2/demos/issues/442>)
  * use serialized message (#441 <https://github.com/ros2/demos/issues/441>)
  * Replace deprecated launch_ros usage (#437 <https://github.com/ros2/demos/issues/437>)
  * code style only: wrap after open parenthesis if not in one line (#429 <https://github.com/ros2/demos/issues/429>)
  * Use spin_until_future_complete instead of spin_some in parameters_event demo (#427 <https://github.com/ros2/demos/issues/427>)
  * change the logging demo test for updated console format (#421 <https://github.com/ros2/demos/issues/421>)
  * [demo_nodes_cpp]  Add XML launch demos (#419 <https://github.com/ros2/demos/issues/419>)
  * Contributors: Dirk Thomas, Ivan Santiago Paunovic, Jacob Perron, Karsten Knese, Steven Macenski, William Woodall, Yutaka Kondo

 -- William Woodall <william@osrfoundation.org>  Thu, 30 Apr 2020 07:00:00 -0000

ros-foxy-demo-nodes-cpp (0.8.4-1focal) focal; urgency=high

  * Add in a more helpful usage message to allocator_tutorial. (#409 <https://github.com/ros2/demos/issues/409>)
  * Contributors: Chris Lalancette

 -- William Woodall <william@osrfoundation.org>  Tue, 19 Nov 2019 08:00:00 -0000

ros-foxy-demo-nodes-cpp (0.8.3-1focal) focal; urgency=high



 -- William Woodall <william@osrfoundation.org>  Mon, 11 Nov 2019 08:00:00 -0000

ros-foxy-demo-nodes-cpp (0.8.2-1focal) focal; urgency=high

  * Don't redefine add_dependencies (#408 <https://github.com/ros2/demos/issues/408>)
  * Contributors: Dan Rose

 -- William Woodall <william@osrfoundation.org>  Fri, 08 Nov 2019 08:00:00 -0000

ros-foxy-demo-nodes-cpp (0.8.1-1focal) focal; urgency=high

  * rename return functions for loaned messages (#403 <https://github.com/ros2/demos/issues/403>)
  * Replace ready_fn with ReadyToTest action (#404 <https://github.com/ros2/demos/issues/404>)
  * remove intra-process manager impl (#382 <https://github.com/ros2/demos/issues/382>)
  * zero copy api (#394 <https://github.com/ros2/demos/issues/394>)
  * Remove command line parsing from C++ demos (#401 <https://github.com/ros2/demos/issues/401>)
  * Need to specify NodeOption explicitly to allow declaration. (#389 <https://github.com/ros2/demos/issues/389>)
  * Contributors: Alberto Soragna, Jacob Perron, Karsten Knese, Peter Baughman, tomoya

 -- William Woodall <william@osrfoundation.org>  Wed, 23 Oct 2019 07:00:00 -0000

ros-foxy-demo-nodes-cpp (0.8.0-1focal) focal; urgency=high

  * Adding visibility macros to demos (#381 <https://github.com/ros2/demos/issues/381>)
  * Demos using composition (#375 <https://github.com/ros2/demos/issues/375>)
  * Contributors: Siddharth Kucheria

 -- William Woodall <william@osrfoundation.org>  Thu, 26 Sep 2019 07:00:00 -0000

ros-foxy-demo-nodes-cpp (0.7.6-1focal) focal; urgency=high



 -- William Woodall <william@osrfoundation.org>  Thu, 30 May 2019 07:00:00 -0000

ros-foxy-demo-nodes-cpp (0.7.5-1focal) focal; urgency=high

  * Update to use new parameter option names (#355 <https://github.com/ros2/demos/issues/355>)
  * Contributors: William Woodall

 -- William Woodall <william@osrfoundation.org>  Wed, 29 May 2019 07:00:00 -0000

ros-foxy-demo-nodes-cpp (0.7.4-1focal) focal; urgency=high



 -- William Woodall <william@osrfoundation.org>  Mon, 20 May 2019 07:00:00 -0000

ros-foxy-demo-nodes-cpp (0.7.3-1focal) focal; urgency=high

  * Added the ``parameter_blackboard`` demo to ``demo_nodes_cpp`` to make some tutorials easier. (#333 <https://github.com/ros2/demos/issues/333>)
  * Contributors: William Woodall

 -- William Woodall <william@osrfoundation.org>  Fri, 10 May 2019 07:00:00 -0000

ros-foxy-demo-nodes-cpp (0.7.2-1focal) focal; urgency=high

  * changes to avoid deprecated API's (#332 <https://github.com/ros2/demos/issues/332>)
  * Corrected publish calls with shared_ptr signature (#327 <https://github.com/ros2/demos/issues/327>)
  * Migrate launch tests to new launch_testing features & API (#318 <https://github.com/ros2/demos/issues/318>)
  * Contributors: Michel Hidalgo, William Woodall, ivanpauno

 -- William Woodall <william@osrfoundation.org>  Wed, 08 May 2019 07:00:00 -0000

ros-foxy-demo-nodes-cpp (0.7.1-1focal) focal; urgency=high

  * Updated to declare parameters. (#241 <https://github.com/ros2/demos/issues/241>)
  * Contributors: Shane Loretz

 -- William Woodall <william@osrfoundation.org>  Fri, 26 Apr 2019 07:00:00 -0000

ros-foxy-demo-nodes-cpp (0.7.0-1focal) focal; urgency=high

  * Moved away from deprecated rclcpp APIs. (#321 <https://github.com/ros2/demos/issues/321>)
  * Added launch along with launch_testing as test dependencies. (#313 <https://github.com/ros2/demos/issues/313>)
  * Updated for NodeOptions Node constructor. (#308 <https://github.com/ros2/demos/issues/308>)
  * Contributors: Emerson Knapp, Michael Carroll, Michel Hidalgo

 -- William Woodall <william@osrfoundation.org>  Sun, 14 Apr 2019 07:00:00 -0000

ros-foxy-demo-nodes-cpp (0.6.2-1focal) focal; urgency=high



 -- William Woodall <william@osrfoundation.org>  Tue, 15 Jan 2019 08:00:00 -0000

ros-foxy-demo-nodes-cpp (0.6.1-1focal) focal; urgency=high



 -- William Woodall <william@osrfoundation.org>  Thu, 13 Dec 2018 08:00:00 -0000

ros-foxy-demo-nodes-cpp (0.6.0-1focal) focal; urgency=high



=== debian/control ===
Source: ros-foxy-demo-nodes-cpp
Section: misc
Priority: optional
Maintainer: Mabel Zhang <mabel@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), ros-foxy-ament-cmake, ros-foxy-ament-cmake-pytest, ros-foxy-ament-lint-auto, ros-foxy-ament-lint-common, ros-foxy-example-interfaces, ros-foxy-launch, ros-foxy-launch-testing, ros-foxy-launch-testing-ament-cmake, ros-foxy-launch-testing-ros, ros-foxy-rclcpp, ros-foxy-rclcpp-components, ros-foxy-rcutils, ros-foxy-rmw, ros-foxy-rmw-implementation-cmake, ros-foxy-std-msgs, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-demo-nodes-cpp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-foxy-example-interfaces, ros-foxy-launch-ros, ros-foxy-launch-xml, ros-foxy-rclcpp, ros-foxy-rclcpp-components, ros-foxy-rcutils, ros-foxy-rmw, ros-foxy-std-msgs, ros-foxy-ros-workspace
Description: C++ nodes which were previously in the ros2/examples repository but are now just used for demo purposes.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-demo-nodes-cpp//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
